<?php
/*******************************************************************************************
*   Script du module GestFiles réalisé par Gquick pour le projet JBC Explorer v7+
*   Site web du projet : http://jcjcjcjc.free.fr/
*   Forum du projet : http://www.freescript.be/viewforum.php?forum=10
*   Forum du module : http://www.freescript.be/viewtopic.php?topic=???&forum=16
*
*  Ce Module est basé sur les travaux de JPR
*
*  FONCTIONS DU MODULE
*
*  Evolutions :
*  v 1.00	06/03/2005	Gquick		Création sous forme de module
*								avec reprise des travaux de JPR
*  v 1.01	07/03/2005	Gquick		Corrections Bug
*		- Correction Bug de la gestion <input type=image> qui ne passe comme un submit sous IE
*		- Ajout vérification stricte des noms des répertoires créer
*  v 1.02	17/03/2005	Gquick		Ajout fonction de renommage de fichier,
*								simplification de la mise en forme,
*								généralisation de la méthode de patch
*								ajout de la fonction en mode miniature
*  v 1.03	18/03/2005	Gquick		Correction Bug "selectionner tout"
*  v 1.04	19/03/2005	Gquick		Correction Bugs de mise en forme
*								et sur renommage des dossiers
*								ajout robustesse sur le hacking
*  v 1.05	20/05/2005	Gquick		Compatibilité avec Explorer 7.05
*  v 1.06	20/05/2005 	Polysosycs & Gquick
*								Ajout de la compression au format zip
*								et de la décomptession au format zip, tar.gz, tgz, tar
*								utilise la librairie pclzip
*  v 1.07	10/09/2005 	Gquick & gdecad
*								Modif de gf_print_footer pour le rendre compatible du module find
*								Modif suppression répertoire pour être compatible info fichier
*  v 1.08	06/11/2005 	Gquick
*								Correction Bug sur fichiers avec un '
*******************************************************************************************/

@session_start();    			// demarre une session si ce n'est déja fait
$hack_module['GestFiles']=true;	// signifie que le module existe et a été inclus correctement
$gf_version='1.08';

$gf_isauth=gf_isauthentify();	// mode authentifiée ou non
$gf_checked_all='';				// '' ou 'checked ' (état initiale des cases a cocher)

// ------------------------------------------------------------------------------------------------------------------------------------------------
// PUBLIC function
// ------------------------------------------------------------------------------------------------------------------------------------------------
/**
	* Supprimer un répertoire non vide
*/
function suppressionrepertoire($dir)
{
	//Liste le contenu du répertoire dans un tableau
	$dir_content = scandir($dir);
	//Est-ce bien un répertoire?
	if($dir_content !== FALSE){
		//Pour chaque entrée du répertoire
		foreach ($dir_content as $entry)
		{
			//Raccourcis symboliques sous Unix, on passe
			if(!in_array($entry, array('.','..'))){
				//On retrouve le chemin par rapport au début
				$entry = $dir . '/' . $entry;
				//Cette entrée n'est pas un dossier: on l'efface
				if(!is_dir($entry)){
					unlink($entry);
				}
				//Cette entrée est un dossier, on recommence sur ce dossier
				else{
					suppressionrepertoire($entry);
				}
			}
		}
	}
	//On a bien effacé toutes les entrées du dossier, on peut à présent l'effacer
	rmdir($dir);
}



/**
	* Récupération du chemin complet d'un icone
	* @Public
	* @Global array $CONFIG		tableau de config de l'explorer
	* @param string $path_prefix	chemin relatif pour retourner a .dirsys
	* @param string $icon_name	Nom de l'icone a récupérer
	* @return String				Chemin complet de l'icone
*/
function gf_getIcon($path_prefix,$icon_name) {
	global $CONFIG;
	// Recherche d'abord dans le dossier icone puis dans le dossier du module
	$icon_path=$path_prefix.$CONFIG['ICO_FOLDER'].'/'.$icon_name.'.png';
	if (file_exists($icon_path)) return($icon_path);
	$icon_path=$path_prefix.$CONFIG['ICO_FOLDER'].'/'.$icon_name.'.gif';
	if (file_exists($icon_path)) return($icon_path);
	$icon_path=$path_prefix.'modules/gestfiles/icones/'.$icon_name.'.png';
	if (file_exists($icon_path)) return($icon_path);
	$icon_path=$path_prefix.'modules/gestfiles/icones/'.$icon_name.'.gif';
	return($icon_path);
}

/**
	* Ajoute un colonne pour les cases a cocher dans la tableau
	* @return none
*/
function gf_print_header() {
	echo "<td style=width:17px>&nbsp;</td>";
}

/**
	* Ajoute la cases a cocher dans le tableau
	* @Public
	* @Global string $gf_checked_all	état initiales des cases a cocher "" ou "checked"
	* @param string $file_path		chemin du fichier concernée
	* @return none
*/
function gf_print_checkbox($file_path) {
global $gf_checked_all;
	//echo "<td style='width:17px'>";
	if ( is_file($file_path) or is_dir($file_path) ) {
		 return "<input type=checkbox name=selected_files[] value=\"$file_path\" $gf_checked_all>";
	} else return "&nbsp";
	//echo "</td>";
}

/**
	* Ajoute la cases a cocher dans les miniatures
	* @Public
	* @Global string $gf_checked_all	état initiales des cases a cocher "" ou "checked"
	* @param string $file_path		chemin du fichier concernée
	* @return none
*/
function gf_print_checkbox_tn($file_path) {
global $gf_checked_all;
	if ( is_file($file_path) or is_dir($file_path) ) {
		echo "<input type=checkbox name=selected_files[] value=\"$file_path\" $gf_checked_all>";
	}
}

/**
	* Ajoute le bandeau de gestion des fichiers
	* @Global array $_SESSION
	* @param string $path_prefix	chemin relatif pour retourner a .dirsys
	* @return none
*/
function gf_print_footer($path_prefix='./') {
global $gf_checked_all;
	$icon_space=str_repeat("&nbsp",5);
	echo '<table class=gestfile border=0 cellspacing=0 cellpadding=1 width=100%><TR valign=center>';
	echo "<TD width=5%>";
	if (empty($gf_checked_all)) {
		echo "<input type=checkbox name='action' onClick='javascript:document.gestfiles.submit()' value='Cocher'>";
	} else {
		echo "<input type=checkbox name='action' onClick='javascript:document.gestfiles.submit()' value='Décocher' checked>";
	}
	echo "</TD><TD width=10%>Appliquer à la selection :</TD><TD align=left width=40%>
		  $icon_space<input type=image src='".gf_getIcon($path_prefix,'delete')."' name='Delete' value='Delete' alt='Effacer' title='Effacer' align='middle'>
		  $icon_space<input type=image src='".gf_getIcon($path_prefix,'zip')."' name='Zip' value='Zip' alt='Compresser-Décompresser' title='Compresser-Décompresser' align='middle'>
		  $icon_space<input type=image src='".gf_getIcon($path_prefix,'copy')."' name='Copy' value='Copy' alt='Copier' title='Copier' align='middle'>
		  $icon_space<input type=image src='".gf_getIcon($path_prefix,'cut')."' name='Cut' value='Cut' alt='Couper' title='Couper' align='middle'>";
	if (isset($_SESSION['Memo_selected_files']) and	isset($_SESSION['Memo_action'])) {
		echo "$icon_space<input style='background-color:white' type=image src='".gf_getIcon($path_prefix,'paste')."' name='Paste' value='Paste' alt='Coller' title='Coller' align='middle'>";
		echo "<small> ".count($_SESSION['Memo_selected_files']) ." fichier(s) </small>";
	}
	echo "</TD>";
	echo "<TD align=right width=22%>Créer un dossier :</TD>";
	echo "<TD align=left width=13%><input type='text' name=NewName size=20 maxlength=20 align='middle' title='Nom du dossier &agrave; créer, du fichier &agrave; renommer ou du fichier zip'>&nbsp;</TD>";
	echo "<TD align=left width=20%>";
	echo "<input type=image src='".gf_getIcon($path_prefix,'newfolder')."' name='CreateNewFolder' value='CreateNewFolder' alt='Créer dossier' title='Créer dossier' align='middle'>";
	echo "&nbsp;/&nbsp;";
	echo "<input type=image src='".gf_getIcon($path_prefix,'ren')."' name='Rename' value='Rename' alt='Renommer' title='Renommer' align='middle'>";
	echo "</TD></TR></table></form>";
}

// ------------------------------------------------------------------------------------------------------------------------------------------------
// PRIVATE function
// ------------------------------------------------------------------------------------------------------------------------------------------------

/**
	* Test si on est en mode authentifiée
	* @Private
	* @return boolean			true/false
*/
function gf_isauthentify() {
global $CONFIG;
	$module_path=str_replace('\\','/',dirname(__FILE__)).'/../';
	include_once($module_path.'auth/func.inc.php');
	if (CheckAuth($module_path.'/auth/auth.inc.php')===1) return(true);
	return(false);
}


/**
	* Nétoie une chaine des caractères spéciaux
	* @Private
	* @param string $str			la chaine a traiter
	* @return string				la chaine alphanumérique [a-zA-Z0-9.]
*/
function gf_cleanStr($str) {
	$str=trim($str);
	$str=preg_replace('[ \']','_',$str);	// espace et ' => _
	$str=preg_replace('[\.+]','.',$str);	// un seul . de suite
	$str=preg_replace('[àâäãáåÀÁÂÃÄÅæÆ]','a',$str);
	$str=preg_replace('[çÇ]','c',$str);
	$str=preg_replace('[éèêëÉÈÊËE]','e',$str);
	$str=preg_replace('[îïìíÌÍÎÏ]','i',$str);
	$str=preg_replace('[ôöðòóÒÓÔÕÖ]','o',$str);
	$str=preg_replace('[ùúûüÙÚÛÜ]','u',$str);
	$str=preg_replace('[ýÿÝŸ]','y',$str);
	return preg_replace("/[^[:alnum:]._]/","",$str); // vire les autres caractères non alphanum . ou _
}


/**
	* Réalise les actions qui ont été passées par _POST
	* utilise la 	_SESSION courrante
	* @Private
	* @Global array $CONFIG			tableau de config de l'explorer
	* @Global string $gf_checked_all	état initiales des cases a cocher "" ou "checked"
	* @Global boolean $gf_isauth		status authentification
	* @param string $current_path		chemin actuel
	* @return none
*/
function gf_do_action($current_path) {
global $CONFIG;
global $gf_checked_all;
global $gf_isauth;

	if (!isset($gf_isauth) or !$gf_isauth) return;
	if (!isset($current_path) or empty($current_path)) return;
	if (!isset($gf_checked_all)) $gf_checked_all='';
	echo "<form name=gestfiles method=post>";
	//
	// Détermine si une action a eu lieu et si oui laquel (Delete/Copy/Cut/Paste/...)
	$action=null;
	// Cas des post par input type=image
	foreach ($_POST as $key=>$value) {
		$tmp_action=substr($key,0,-2);
		if ( ('_x'==substr($key,-2)) and isset($_POST[$tmp_action . '_y']) ) {
			$action=$tmp_action;
			break;
		}
	}
	if (null==$action and isset($_POST['action'])) $action=$_POST['action'];

	//  Le tableau des fichiers sélectionnées est passée dans $_POST[selected_files]
	$selected_files=array();
	if (isset($_POST['selected_files'])) $selected_files=$_POST['selected_files'];
	//  Le Nom d'un nouveau dossier ou d'un fichier est passé dans $_POST['NewName']
	$NewName='';
	if (isset($_POST['NewName'])) {
		$NewName=gf_cleanStr($_POST['NewName']);
		if(!empty($NewName)) {
			if ($action!='Zip') {
				if (count($selected_files)>0) $action='Rename'; // Sécurité dans le cas de l'appuie sur enter
				else $action='Créer dossier'; // Sécurité dans le cas de l'appuie sur enter
			}
		}
	}
	$raz_memo=false;

	switch ($action) {
		case 'Delete':
			// Effacement des fichiers sélectionnées
			foreach ($selected_files as $filename) {
				$filename=trim($filename); // Par précaution
				$local_name=str_replace($CONFIG['DOCUMENT_ROOT'],'',$filename);
				if (is_file($filename)) {
					if (!@unlink($filename)) 
						echo "<B><font color=red>ERREUR de suppression du fichier $local_name</font></B><BR>";
				} elseif (is_dir($filename)) {
					if (is_file($filename.DIRECTORY_SEPARATOR.'.dirinfo')) 
						@unlink($filename.DIRECTORY_SEPARATOR.'.dirinfo');
					if (!suppressionrepertoire($filename)); 
						//echo "<B><font color=red>Le répertoire $local_name a été supprimé.</font></B><BR>";
				}
			}
			$raz_memo=true;
			break;
		case 'Copy':
		case 'Cut':
			// Mémorisation des fichiers sélectionnées dans la session et de l'action
			$_SESSION['Memo_selected_files']=$selected_files;
			$_SESSION['Memo_action']=$action;
			$raz_memo=false;
			break;
		case 'Paste':
			if (isset($_SESSION['Memo_selected_files']) and
				isset($_SESSION['Memo_action'])) {
				foreach ($_SESSION['Memo_selected_files'] as $filename) {
					$filename=trim($filename); // Par précaution
					$local_name=str_replace($CONFIG['DOCUMENT_ROOT'],'',$filename);
					if (is_file($filename)) {
						$new_filename=trim($current_path.basename($filename));
						$new_local_name=str_replace($CONFIG['DOCUMENT_ROOT'],'',$new_filename);
						switch ($_SESSION['Memo_action']) {
							case 'Copy':
								if (!gf_secure_copy($filename,$new_filename)) echo "<B><font color=red>ERREUR de copie de $local_name => $new_local_name</font></B><BR>";
								break;
							case 'Cut':
								if (!gf_secure_rename($filename,$new_filename)) echo "<B><font color=red>ERREUR de déplacement de $local_name => $new_local_name</font></B><BR>";
								break;
						}
					} else echo "<B><font color=red>IMPOSSIBLE de couper/copier/coller un répertoire ($local_name)</font></B><BR>";
				}
			}
			$raz_memo=true;
			break;
		case 'Zip':
			$files_to_zip=array();
			foreach ($selected_files as $filename) {
				// On détermine si l'on doit compresser ou décompresser
				$filepath = pathinfo($filename);
				if (is_dir($filename)) {
					$files_to_zip[]=$filename; // C'est un répertoire => On mémorise pour compression
				} elseif (is_file($filename)) {
					// C'est un fichier => On le décompresse si on reconnait l'extention sinon on le mémorise pour compression
					switch (strtolower($filepath['extension'])) {
						case 'zip':
							@include_once('pclzip.lib.php');
							@include_once('gestfiles.conf.php');
							$zip= new PclZip($filename);
							if (0==($list = $zip->listContent())) {die("Error : ".$zip->errorInfo(true));}
							if (gf_verif_listContent($list)) {
								if ($GESTFILES_CONF['ZIP_PATH']) {
									@$zip->extract(PCLZIP_OPT_PATH, $filepath['dirname']);
								} else {
									@$zip->extract(PCLZIP_OPT_PATH, $filepath['dirname'],PCLZIP_OPT_REMOVE_ALL_PATH);
								}
							} else {
								echo "<B><FONT color=red>ERREUR: Le fichier ".$filepath['basename']." contient des fichiers non autorisés, la décompression a été interronpu !</FONT></B><BR>";
							}
						break;
						case 'gz':
						case 'tgz':
						case 'tar':
							@include_once('pclerror.lib.php');
							@include_once('pcltrace.lib.php');
							@include_once('pcltar.lib.php');
							$list = PclTarList($filename);
							if (gf_verif_listContent($list)) {
								PclTarExtract($filename, $filepath['dirname']);
							} else {
								echo "<B><FONT color=red>ERREUR: Le fichier ".$filepath['basename']." contient des fichiers non autorisés, la décompression a été interronpu !</FONT></B><BR>";
							}
						break;
						default:
							// Mémorisation pour compression ulterieur
							$files_to_zip[]=$filename;
						break;
					}
				}
			}
			if (!empty($files_to_zip)) {
				// Compression des fichiers mémorisées
				@include_once('pclzip.lib.php');
				@include_once('pclerror.lib.php');
				@include_once('pcltrace.lib.php');
				@include_once('pcltar.lib.php');
				@include_once('gestfiles.conf.php');
				if(empty($NewName)) $NewName=basename($filename);
				if ('.zip'==$GESTFILES_CONF['ZIP_FORMAT']) {
					$zip= new PclZip($current_path.$NewName.".zip");
					if ($GESTFILES_CONF['ZIP_PATH']) {
						$file_list = $zip->create($files_to_zip,PCLZIP_OPT_REMOVE_PATH,$current_path);
					} else {
						$file_list = $zip->create($files_to_zip,PCLZIP_OPT_REMOVE_ALL_PATH);
					}
					if (0==$file_list) {die("Error : ".$zip->errorInfo(true));}
				
				} else {
					PclTarCreate($current_path.$NewName.$GESTFILES_CONF['ZIP_FORMAT'],$files_to_zip,'','',$current_path);
				}
			}
			break;			
		case 'Cocher':
			$gf_checked_all='checked';
			break;
		case 'Décocher':
			$gf_checked_all='';
			break;
		case 'Créer dossier':
			if (!empty($NewName)) {
				$local_name=str_replace($CONFIG['DOCUMENT_ROOT'],'',$current_path.$NewName);
				if (!@mkdir($current_path.$NewName,0777)) echo "<B><font color=red>ERREUR de création du repertoire $local_name</font></B><BR>";
				$file ="<?php header('Location: ../index.php');?>";
				file_put_contents("../$local_name/index.php", $file);
				}
			$raz_memo=false;
			break;
		case 'Rename':
			if ( (!empty($NewName)) and count($selected_files)>0 ) {
				$mutli_rename=(count($selected_files)>1);
				$nb=1;
				foreach ($selected_files as $filename) {
					$filename=trim($filename); // Par précaution
					$local_name=str_replace($CONFIG['DOCUMENT_ROOT'],'',$filename);
					$filepath = pathinfo($filename);
					$ext='';
					if (isset($filepath['extension'])) $ext='.'.$filepath['extension'];
					$NewName=str_replace('.','_',$NewName); // Par précaution pour éviter les PB extention interprétables
					if ($mutli_rename) {
						$new_filename=$filepath['dirname'].DIRECTORY_SEPARATOR.$NewName.'_'.sprintf('%03d',$nb).$ext;
					} else {
						$new_filename=$filepath['dirname'].DIRECTORY_SEPARATOR.$NewName.$ext;
					}
					$new_local_name=str_replace($CONFIG['DOCUMENT_ROOT'],'',$new_filename);
					if (!gf_secure_rename($filename,$new_filename)) echo "<B><font color=red>ERREUR de déplacement de $local_name => $new_local_name</font></B><BR>";
					$nb++;
				}
			}
			$raz_memo=true;
			break;
	}
	if ($raz_memo) {
		// Vide l'action Mémorisée
		unset($_SESSION['Memo_selected_files']);
		unset($_SESSION['Memo_action']);
	}
}

/**
	* Copie sécurisée d'un fichier (on renome le fichier s'il existe déjà)
	* @Private
	* @Param string $full_filename		Chemin et Nom du fichier source
	* @Param string $new_full_filename	Chemin et Nom du fichier destination
	* @return boolean				true/false
*/
function gf_secure_copy($full_filename,$new_full_filename) {
	if (empty($full_filename) or empty($new_full_filename)) return(false);
	$file_path=dirname($new_full_filename);
	$file_name=basename($new_full_filename);
	$nbcopy=0;
	while (file_exists($new_full_filename)) {
		$nbcopy++;
		$new_full_filename=$file_path . DIRECTORY_SEPARATOR . '['. $nbcopy .']_' . $file_name;
	}
	return(@copy($full_filename,$new_full_filename));
}

/**
	* Renommage sécurisée d'un fichier (on renome le fichier s'il existe déjà)
	* @Private
	* @Param string $full_filename		Chemin et Nom du fichier source
	* @Param string $new_full_filename	Chemin et Nom du fichier destination
	* @return boolean				true/false
*/
function gf_secure_rename($full_filename,$new_full_filename) {
	if (empty($full_filename) or empty($new_full_filename)) return(false);
	$file_path=dirname($new_full_filename);
	$file_name=basename($new_full_filename);
	$nbcopy=0;
	while (file_exists($new_full_filename)) {
		$nbcopy++;
		$new_full_filename=$file_path . DIRECTORY_SEPARATOR . '['. $nbcopy .']_' . $file_name;
	}
	return(@rename($full_filename,$new_full_filename));
}

/**
	* Vérification qu'une liste de fichier ne contient pas de fichiers exécutables
	* @Private
	* @Param string[] $file_list			Liste de nom de fichiers au format listcontent
	* @return boolean				true/false
*/
function gf_verif_listContent($list) {
	// Liste des fichiers interdits à la décompression.
	$prohibit = array ('.php', '.php3', '.php4', '.php5', '.pl', '.phtml');	
	for ($i=0; $i<sizeof($list); $i++) {
		for ($j=0; $j<sizeof($prohibit); $j++) {
			if (preg_match("/($prohibit[$j])/", $list[$i]['filename'])) return(false);
		}
	}
	return(true);
}

/**
	* Calcul et affiche l'efficacité de la compression
	* @Private
	* @Param string $file_name		Nom du fichier
	* @Param long $original_size		Taille du fichier
	* @return float					Taux de compression
*/
function gf_gain_compression($filename,$original_size) {
	$new_size = filesize($filename);
	$diff = $original_size-$new_size;
	$pc = round($diff/$size1*100, 2);
	if ($pc > 0) {
         echo "<B><font color=green>Taux de compression : $pc %.</font><B>";
	} else {
		echo "<B><font color=green>Taux de compression : </font><font color=red>$pc %.</font><B>";
	}
}

// creation d'une fonction file_put_content si le script est en PHP4 :
if(!function_exists('file_put_contents')) {
	function file_put_contents($filename, $data, $file_append = false) {
		$fp = fopen($filename, (!$file_append ? 'w+' : 'a+'));
		if(!$fp) {
		trigger_error('file_put_contents ne peut pas écrire dans le fichier.', E_USER_ERROR);
		return;
		}
		fputs($fp, $data);
		fclose($fp);
		}
		}
?>
