<?php
/*******************************************************************************************
*   Script du module GestFiles ralis par Gquick pour le projet JBC Explorer v7+
*   Site web du projet : http://jcjcjcjc.free.fr/
*   Forum du projet : http://www.freescript.be/viewforum.php?forum=10
*   Forum du module : http://www.freescript.be/viewtopic.php?topic=???&forum=16
*
*  FONCTIONS DU MODULE spcifique au PATCH / HACK de code
*
*  Evolutions :
*  v 1.04	19/03/2005	Gquick		Cration sous forme de module
*								avec adaptation des fonctions prcdentes
*******************************************************************************************/
// ------------------------------------------------------------------------------------------------------------------------------------------------
// PRIVATE function
// ------------------------------------------------------------------------------------------------------------------------------------------------

/**
	* Test si le hack code ncessaire au module est prsent dans les fichiers list.php et list.inc.php
	* @Private
	* @return boolean			true/false
*/
function gf_hack_gestfiles_test() {
	$hack_tag='~~<HACK_MODULE_GESTFILES>~~';
	$hack_path=str_replace('\\','/',dirname(__FILE__)).'/../../';
	if (!file_exists($hack_path.'list.php')) return(false);
	if (!file_exists($hack_path.'list.inc.php')) return(false);
	if (!file_exists($hack_path.'showtn.php')) return(false);
	$hack_number=0;
	// Parcours le fichier list.php pour compter le nombre de tag de hack
	$list_php=file($hack_path.'list.php');
	foreach ($list_php as $line) {
		if (strstr($line,$hack_tag)) $hack_number++;
	}
	unset($list_php);
	// Parcours le fichier list.inc.php pour compter le nombre de tag de hack
	$list_inc_php=file($hack_path.'list.inc.php');
	foreach ($list_inc_php as $line) {
		if (strstr($line,$hack_tag)) $hack_number++;
	}
	unset($list_inc_php);
	// Parcours le fichier showtn.php pour compter le nombre de tag de hack
	$showtn_php=file($hack_path.'showtn.php');
	foreach ($showtn_php as $line) {
		if (strstr($line,$hack_tag)) $hack_number++;
	}
	unset($showtn_php);
	// Il devrait il avoir 10 Tag au total
	return(10==$hack_number);
}


/**
	* Applique un patch  un fichier
	* @Private
	* @Param array $patch		Structure decrivant le patch a appliquer
	* @return boolean			true/false
*/
function gf_apply_patch($patch) {
	if (!is_writable($patch['file_path'])) {
		echo "<p class='status_nok'><b>Err Patch</b> - Ecriture impossible dans ".$patch['file_path']."</p>";
		return(false);
	}
	$md5_ok=false;
	$md5=md5_file($patch['file_path']);
	foreach ($patch['md5'] as $md5_test) {
		if ($md5==$md5_test) {
			$md5_ok=true;
			break;
		}
	}
	if (!$md5_ok) {
		echo "<p class='status_nok'><b>Err Patch</b> - MD5(".$patch['file_path'].")=$md5</p>";
		return(false);
	}
	// On commence par lire le fichier puis on le copie pour backup
	$file_source=file($patch['file_path']);
	if (!gf_secure_copy($patch['file_path'],$patch['file_path'].'.bak')) return(false);
	$f=fopen($patch['file_path'],'w');
	echo 'PATCH '.$patch['file_path'].'<br>';
	$hack_add=0;
	foreach ($file_source as $indice=>$line) {
		$no=$indice+1;
		if (isset($patch['source_code'][$no]) and (0==strpos(trim($line),trim($patch['source_code'][$no])))) {
			echo "Hack insr Ligne $no<br>";
			fputs($f,$patch['hack_code'][$no]."\r\n");
			$hack_add++;
		}
		fputs($f,$line);
	}
	fclose($f);
	if (count($patch['source_code'])==$hack_add) {
		echo '<p class="status_ok"><b>&laquo;Hacking&raquo; du code OK</b> - ';
		echo $hack_add." / ".count($patch['source_code'])." Modifications ajoutes</p>";
		return(true);
	}
	// Ensemble des modifs non applique => retour a la case dpart via le backup
	echo '<p class="status_nok"><b>!!! ERREUR !!! lors du &laquo;Hacking&raquo; du code</b> - ';
	echo "Seulement $hack_add / ".count($patch['source_code'])." Modifications ajoutes</p>";
	echo '<p>Restauration de la sauvegarde :<br>';
	if (!@rename($patch['file_path'].'.bak',$patch['file_path'])) echo "<b>OK</b></p>";
	return(false);	
}


/**
	* Ajout le code ncessaire au module dans les fichiers list.php et list.inc.php
	* @Private
	* @return boolean			true/false
*/
function gf_hack_gestfiles_add() {
	$hack_tag='~~<HACK_MODULE_GESTFILES>~~';
	$hack_path=str_replace('\\','/',dirname(__FILE__)).'/../../';

	$patch[0]['file_path']=$hack_path.'list.php';
	if (file_exists($hack_path.'modules/commentaires.php')) {
		// Le module commentaire est install => hack spcifique
		$patch[0]['md5'][0]='464f637c146c054874615bd7f60dbb86'; // format windows (transfert binaire)
		$patch[0]['md5'][1]='f1e635a28434f6d3f1fcbacc2f5b3353'; // format unix (transfert ascii)
		$patch[0]['source_code'] = array(
									  2 => "include_once('./config.inc.php');",
									 51 => '<td colspan="2" class="miniatureliste" >',
									 80 => '<td style="width:17px"><a href="<?php echo \'list.php\'.$back_url_query ?>" >',
									164 => '<td style="width:17px"><?php echo $request_link ?>',
									213 => "</body>"
								);
		$patch[0]['hack_code'] = array(
									  2 => "@include_once('./modules/gestfiles/gestfiles.func.php'); //$hack_tag",
									 51 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_header(); //$hack_tag ?>",
									 80 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_header(); //$hack_tag ?>",
									164 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_checkbox(\$link.\$val); //$hack_tag ?>",
									213 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_footer(); //$hack_tag ?>"
							  );
	} else {
		$patch[0]['md5'][0]='2b47a1fae070e9565935edb4be7b93de'; // format windows (transfert binaire)
		$patch[0]['md5'][1]='c5f0712833ebcb3ef59a2c57f057a54c'; // format unix (transfert ascii)
		$patch[0]['source_code'] = array(
									  2 => "include_once('./config.inc.php');",
									 33 => '<td colspan="2" class="miniatureliste" >',
									 52 => '<td style="width:17px"><a href="<?php echo \'list.php\'.$back_url_query ?>" >',
									118 => '<td style="width:17px"><?php echo $request_link ?>',
									131 => "</body>"
								);
		$patch[0]['hack_code'] = array(
									  2 => "@include_once('./modules/gestfiles/gestfiles.func.php'); //$hack_tag",
									 33 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_header(); //$hack_tag ?>",
									 52 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_header(); //$hack_tag ?>",
									118 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_checkbox(\$link.\$val); //$hack_tag ?>",
									131 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_footer(); //$hack_tag ?>"
							  );
	}
	gf_apply_patch($patch[0]);
	
	$patch[1]['file_path']=$hack_path.'list.inc.php';
	$patch[1]['md5'][0]='a8c86e74d9c1a71df4463231a7810cde'; // V7.01 format windows (transfert binaire)
	$patch[1]['md5'][1]='44d275d28b69bb4c667b02180f0149da'; // V7.01 format unix (transfert ascii)
	$patch[1]['md5'][2]='5fd2a75c736fc1b65520d6affe7e8b3c'; // V7.05 format windows (transfert binaire)
	$patch[1]['md5'][3]='22fd014345e2f30e53f4f0e6ffdec3d4'; // V7.05 format unix (transfert ascii)
	$patch[1]['source_code'] = array(
								29 => "\$handle_source=@opendir(\$link) or die(\$LANGUE['ERR_Config']);",
							);
	$patch[1]['hack_code'] = array(
								29 => "if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_do_action(\$link); //$hack_tag",
						  );
						  
	gf_apply_patch($patch[1]);

	$patch[2]['file_path']=$hack_path.'showtn.php';
	if (file_exists($hack_path.'modules/commentaires.php')) {
		// Le module commentaire est install => hack spcifique
		$patch[2]['md5'][0]='ffc6deed3dc550a0b60bc07cfd7f3634'; // format windows (transfert binaire)
		$patch[2]['md5'][1]='03ec681f9afbd00943a245045f1e1a00'; // format unix (transfert ascii)
		$patch[2]['source_code'] = array(
									  2 => "include_once('./config.inc.php');",
									 51 => '<tr>',
									148 => '<?',
									190 => '</body>'
								);
		$patch[2]['hack_code'] = array(
									  2 => "@include_once('./modules/gestfiles/gestfiles.func.php'); //$hack_tag",
									 51 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_header(); //$hack_tag ?>",
									148 => "<br><?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_checkbox_tn(\$link.\$val); //$hack_tag ?>",
									190 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_footer(); //$hack_tag ?>"
							  );
	} else {
		$patch[2]['md5'][0]='b5cff9267c9cc133737b5ff452f3b4f0'; // format windows (transfert binaire)
		$patch[2]['md5'][1]='84153d971ec98afa8bec9e6cbd532072'; // format unix (transfert ascii)
		$patch[2]['source_code'] = array(
									  2 => "include_once('./config.inc.php');",
									 33 => '<tr>',
									129 => '</td>',
									137 => '</body>'
								);
		$patch[2]['hack_code'] = array(
									  2 => "@include_once('./modules/gestfiles/gestfiles.func.php'); //$hack_tag",
									 33 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_header(); //$hack_tag ?>",
									129 => "<br><?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_checkbox_tn(\$link.\$val); //$hack_tag ?>",
									137 => "<?php if (isset(\$hack_module['GestFiles']) and \$gf_isauth) gf_print_footer(); //$hack_tag ?>"
							  );
	}
	gf_apply_patch($patch[2]); 

	if (!gf_hack_gestfiles_test()) {
		// Fichiers modifis par rapport  la version 7.01 de l'explorer => Modif manuelle
		print <<<END_MANUEL_ADD
		<p class="warning">!!! <b>WARNING</b> !!!
		Vos fichiers <b>list.php</b> et/ou <b>list.inc.php</b> et/ou <b>showtn.php</b> semblent avoir t modifis
		par rapport  la version 7.01 de l'explorer (md5 incorrect)</p>
		<p>Vous devez faire les modifications vous mme :</p>
		<ul>Ln x : code_origine ....<br>Inserer: code_php<br><ul>Signifie que vous devez inserer la nouvelle ligne de code php en ligne x du fichier d'origine<br>
		la ligne x se retouve donc en ligne x+1 (la nouvelle ligne ayant &eacute;t&eacute; ajoute au dessus)</ul></ul>
		<code><ul>
END_MANUEL_ADD;
		echo '<li>Fichier <b>list.php</b> :</li><ul>';
		foreach ($patch[0]['source_code'] as $ln => $src) {
			echo "<li><pre>Ln $ln: ".htmlentities($src)." ...<br>Insrer: ".htmlentities($patch[0]['hack_code'][$ln])."</pre></li>";
		}
		echo '</ul><li>Fichier <b>list.inc.php</b> :</li><ul>';
		foreach ($patch[1]['source_code'] as $ln => $src) {
			echo "<li><pre>Ln $ln: ".htmlentities($src)." ...<br>Insrer: ".htmlentities($patch[1]['hack_code'][$ln])."</pre></li>";
		}
		echo '</ul><li>Fichier <b>showtn.php</b> :</li><ul>';
		foreach ($patch[2]['source_code'] as $ln => $src) {
			echo "<li><pre>Ln $ln: ".htmlentities($src)." ...<br>Insrer: ".htmlentities($patch[2]['hack_code'][$ln])."</pre></li>";
		}
		echo '</ul></ul></code><br>';
		return(false);		
	} else return(true);
}

/**
	* Supprime le hack des fichiers list.php et list.inc.php
	* @Private
	* @return boolean			true/false
*/
function gf_hack_gestfiles_remove() {
	$nb_hack_to_remove=10;
	$hack_tag='~~<HACK_MODULE_GESTFILES>~~';
	$hack_path=str_replace('\\','/',dirname(__FILE__)).'/../../';
	if (!file_exists($hack_path.'list.php')) return(false);
	if (!file_exists($hack_path.'list.inc.php')) return(false);
	if (!file_exists($hack_path.'showtn.php')) return(false);
	// On commence par lire le fichier puis on le copie pour backup
	$hack_removed=0;
	$list_php=file($hack_path.'list.php');
	if (!gf_secure_copy($hack_path.'list.php',$hack_path.'list.php.bak')) return(false);
	$f=fopen($hack_path.'list.php','w');
	foreach ($list_php as $indice => $line) {
		$no=$indice+1;
		if (!strstr($line,$hack_tag)) fputs($f,$line);
		else {
			echo "list.php : Hack supprim Ligne $no<br>";
			$hack_removed++;
		}
	}
	fclose($f);
	unset($list_php);
	$list_inc_php=file($hack_path.'list.inc.php');
	if (!gf_secure_copy($hack_path.'list.inc.php',$hack_path.'list.inc.php.bak')) return(false);
	$f=fopen($hack_path.'list.inc.php','w');
	foreach ($list_inc_php as $line) {
		if (!strstr($line,$hack_tag)) fputs($f,$line);
		else {
			echo "list.inc.php : Hack supprim Ligne $no<br>";
			$hack_removed++;
		}
	}
	fclose($f);
	unset($list_inc_php);
	$showtn_php=file($hack_path.'showtn.php');
	if (!gf_secure_copy($hack_path.'showtn.php',$hack_path.'showtn.php.bak')) return(false);
	$f=fopen($hack_path.'showtn.php','w');
	foreach ($showtn_php as $line) {
		if (!strstr($line,$hack_tag)) fputs($f,$line);
		else {
			echo "showtn.php : Hack supprim Ligne $no<br>";
			$hack_removed++;
		}
	}
	fclose($f);
	unset($showtn_php);
	// Verif nombre de Tag enlevs au total
	if ($nb_hack_to_remove==$hack_removed) {
		echo '<p class="status_ok"><b>&laquo;Restauration&raquo; du code OK</b>';
		echo "&nbsp; - &nbsp; $hack_removed / $nb_hack_to_remove Modifications supprimes</p>";
	} else {
		echo '<p class="status_nok"><b>!!! ERREUR !!! lors de la &laquo;Restauration&raquo; du code OK</b>';
		echo "&nbsp; - &nbsp; Seulement $hack_removed / $nb_hack_to_remove Modifications supprimes</p>";
		echo '<p>Restauration de la sauvegarde :<br>';
		if (!@rename($hack_path.'list.php.bak',$hack_path.'list.php')) echo "list.php.bak => list.php : <b>OK</b><br>";
		else echo "list.php.bak => list.php : <b>ERREUR</b><br>";
		if (!@rename($hack_path.'list.inc.php.bak',$hack_path.'list.inc.php')) echo "list.inc.php.bak => list.inc.php : <b>OK</b><br>";
		else echo "list.inc.php.bak => list.inc.php : <b>ERREUR</b><br>";
		if (!@rename($hack_path.'showtn.php.bak',$hack_path.'showtn.php')) echo "showtn.php.bak => showtn.php : <b>OK</b><br>";
		else echo "showtn.php.bak => showtn.php : <b>ERREUR</b><br>";
	}
	return($nb_hack_to_remove==$hack_removed);
}

?>
